
<cfcontent type="text/html; charset=utf-8">
<cfsetting showDebugOutput="no">

<cfprocessingdirective pageencoding="utf-8">
<cfflush interval="2">
<cfparam default="" name="form.tool" type="string">
<!--- Copyright 2003 by Giampaolo Bellavite 
	  - All rights reserved
--->


<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>bellaAlbum Progress Status</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link href="style.css" rel="stylesheet" type="text/css">
<script language="JavaScript">
function getWidth(progressBarID) {
     theWidth=document.getElementById(progressBarID).style.width;
     theWidth=theWidth.substring(0, (theWidth.length-2));
     return Number(theWidth);
     }
function updateStatus(progressBarID, width, message) {
     document.getElementById(progressBarID).style.width=width+'px';
      document.getElementById('progressBarDescr').innerHTML=message;
     }     
</script>
</head>

<body>
<div id="progressBar" style="position: absolute; top: 270px; left: 30px; height: 16px; width: 299px; background-color: #white; font-family: tahoma, Arial, Helvetica, sans-serif; font-size: 8pt; border: 1px solid black">
<div id="progressBarID" style="height: 14px; width: 0px; background-color: #CCC; font-family: tahoma, Arial, Helvetica, sans-serif; font-size: 8pt;"></div></div>
<div id="progressBarDescr" style="position: absolute; top: 288px; left: 30px; background: white; font-family: tahoma, Arial, Helvetica, sans-serif; font-size: 8pt;"></div>
<h1>&nbsp;&nbsp;bellaAlbum Progress Status</h1>
<p>
	
<!--- Create the directories structure --->

	<cfif directoryExists(form.origDir)>
		<cftry>
			<cfdirectory action="list" name="FileList" directory="#form.origDir#" filter="*.jpg" sort="#form.sortBy#">
			<cfcatch>
				<cfoutput><strong>I cannot create the album.</strong> #cfcatch.Message#</cfoutput><cfabort>
			</cfcatch>
		</cftry>
	<cfelse>
		<cfoutput><strong>I cannot create the album.</strong> The directory "#form.origDir#" doesn't exists.</cfoutput>
	</cfif>
	<strong><cfoutput>#filelist.recordCount#</strong> images into the #form.origDir# directory.</cfoutput><br><br>
	
	<cfif filelist.recordCount EQ 0>
		<strong>I cannot create the album.</strong> Please choose a directory with some JPGs!
		<cfabort>
	</cfif>

	<cfif form.tool EQ "">
		<strong>I cannot create the album.</strong> Please choose an installed image manipulation tool!
		<cfabort>
	</cfif>
	<strong>Please wait...</strong><br><br>
	<cfif NOT directoryExists(form.destDir)>
	<strong>Building directory structure...</strong><br><br>
		<cftry>
			<cfdirectory action="create" directory="#form.destDir#">
			<cfcatch>
				<cfoutput>#cfcatch.Message#</cfoutput><cfabort>
			</cfcatch>
		</cftry>
		<cfoutput>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Directory "#form.destDir#" was created successfully.<br></cfoutput>

		<cftry>
			<cfdirectory action="create" directory="#form.destDir#\images">
			<cfcatch>
				<cfoutput>#cfcatch.Message#</cfoutput><cfabort>
			</cfcatch>
		</cftry>
		<cfoutput>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Directory "#form.destDir#images" was created successfully.<br></cfoutput>
		
		<cftry>
			<cfdirectory action="create" directory="#form.destDir#\thumbs">
			<cfcatch>
				<cfoutput>#cfcatch.Message#</cfoutput><cfabort>
			</cfcatch>
		</cftry>
		<cfoutput>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Directory "#form.destDir#thumbs" was created successfully.<br></cfoutput>

		<cftry>
			<cfdirectory action="create" directory="#form.destDir#\pages">
			<cfcatch>
				<cfoutput>#cfcatch.Message#</cfoutput><cfabort>
			</cfcatch>
		</cftry>
		<cfoutput>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Directory "#form.destDir#pages" was created successfully.<br></cfoutput>

	</cfif>


	<!--- Copy the css file --->
	<cftry>
			<cffile action="copy"  source="#ExpandPath('.')#\album.css" destination="#form.destDir#\album.css">
			<cfcatch>
				<cfoutput>#cfcatch.Message#</cfoutput><cfabort>
			</cfcatch>
 </cftry>
		<cfoutput>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br>Album.css file copied successfully.<br></cfoutput>

	

	<!--- Build an array with the image list --->
	<cfset ImageList = ArrayNew(1)>
	<cfloop query="FileList">
		<cfset ArrayAppend(ImageList, Name)>
	</cfloop>

	<!--- build the thumbnail page --->
	<cfset indexTable = "">
	<br><strong>Building images and thumbnails...</strong><br><br>
	<!--- loop the image list --->

	<cfset lineWidth = 300> 
	<cfset incr = lineWidth \ ArrayLen(ImageList)> 
		<cfset currentWidth = 0>
	<br>	<br>	<br>	<br>
	<cfloop from="1" to="#ArrayLen(ImageList)#" index="i">
		<cfset currentWidth = currentWidth + incr>
		<cfset ImageDescr = Left(ImageList[i], Len(ImageList[i])-4)> <!--- Get the imageDescription from the file name --->
		<cfset TotImages = ArrayLen(ImageList)>
		<cfoutput>
     <script language="JavaScript">
          updateStatus('progressBarID',#CurrentWidth#,'#i#/#ArrayLen(ImageList)# - Processing #JSStringFormat(ImageList[i])#');
     </script>
</cfoutput>
		<!--- build the thumnails images --->
		
		<cfswitch expression="#form.tool#">
			<cfcase value="aurigma">
				<cftry>
					<cfobject type="com" name="objEncoder" class="GraphicsProcessor2002.JPEGEncoderInfo" action="create">
					<cfset objEncoder.Quality = form.JPGQual>
					<cfobject type="COM" name="ObjRaster" class="GraphicsProcessor2002.RasterObject" action="create">
					<cfset objRaster.LoadFile("#form.origDir#\#ImageList[i]#")>
					<cfset ThumbWidth = form.thumbWidth>
					<cfset ThumbHeight = ThumbWidth * (objRaster.Height / objRaster.Width)>
					<cfset objRaster.Resize(ThumbWidth, ThumbHeight)>
					<cfset objRaster.SaveFile("#form.destDir#\thumbs\#ImageList[i]#", objEncoder)>
					<cfcatch>
						<br><strong>Error saving <cfoutput>#ImageList[i]#</cfoutput></strong>: <cfoutput>#cfcatch.Message#</cfoutput><br>
					</cfcatch>
				</cftry>
				<!--- copy original images to the destination directory --->
					<cfif isDefined('form.IMGWIDTHYN')> <!--- if original images not have to be resized... --->
						<cffile action="copy"  source="#form.origDir#\#ImageList[i]#" destination="#form.destDir#\images\#ImageList[i]#">
					<cfelse>
						<cftry>
							<cfobject type="com" name="objEncoderBig" class="GraphicsProcessor2002.JPEGEncoderInfo" action="create">
							<cfset objEncoderBig.Quality = form.JPGQual>
							<cfobject type="COM" name="ObjRasterBig" class="GraphicsProcessor2002.RasterObject" action="create">
							<cfset objRasterBig.LoadFile("#form.origDir#\#ImageList[i]#")>
							<cfset ThumbWidthBig = form.ImagesWidth>
							<cfset ThumbHeightBig = ThumbWidthBig * (objRasterBig.Height / objRasterBig.Width)>
							<cfset objRasterBig.Resize(ThumbWidthBig, ThumbHeightBig)>
							<cfset objRasterBig.SaveFile("#form.destDir#\images\#ImageList[i]#", objEncoderBig)>				
							<cfcatch>
						<br><strong>Error saving <cfoutput>#ImageList[i]#</cfoutput></strong>: <cfoutput>#cfcatch.Message#</cfoutput><br>
							</cfcatch>
						</cftry>
					</cfif>			
			</cfcase>
			<cfcase value="irfanview">
				<cftry>
					<cflock timeout="60" throwontimeout="no" type="exclusive">
						<cfexecute name="#form.irfanPath#" outputfile="temp.txt" arguments="#form.origDir#\#ImageList[i]# /one /dpi=(72,72) /resize=(#form.thumbWidth#,0)  /convert=#form.destDir#\thumbs\#ImageList[i]#"></cfexecute>
					</cflock>
					<cfcatch>
						<br><strong>Error saving <cfoutput>#ImageList[i]#</cfoutput></strong>: <cfoutput>#cfcatch.Message#</cfoutput><br>				
					</cfcatch>
				</cftry>

				<!--- copy original images to the destination directory --->
					<cfif isDefined('form.IMGWIDTHYN')> <!--- if original images not have to be resized... --->
						<cffile action="copy"  source="#form.origDir#\#ImageList[i]#" destination="#form.destDir#\images\#ImageList[i]#">
					<cfelse>
						<cftry>
							<cflock timeout="60" throwontimeout="no" type="exclusive">
								<cfexecute name="#form.irfanPath#" outputfile="temp.txt" arguments="#form.origDir#\#ImageList[i]# /one /dpi=(72,72) /resize=(#form.ImagesWidth#,0)  /convert=#form.destDir#\images\#ImageList[i]#"></cfexecute>
							</cflock>
							<cfcatch>
								<br><strong>Error saving <cfoutput>#ImageList[i]#</cfoutput></strong>: <cfoutput>#cfcatch.Message#</cfoutput><br>				
							</cfcatch>
						</cftry>					
					</cfif>			
					
					<!--- Close all the irfanview instances --->
					<cflock timeout="60" throwontimeout="no" type="exclusive"><cfexecute name="#form.irfanPath#" outputfile="temp.txt" arguments="/killmesoftly"></cfexecute></cflock>
			</cfcase>
		
		</cfswitch>

	
	
	<!--- build single html file for every images --->
		<cfif i - 1 EQ 0>
			<cfset j = ArrayLen(ImageList)>
		<cfelse>
			<cfset j = i - 1>
		</cfif>
		<cfif i + 1 GT ArrayLen(ImageList)>
			<cfset k = 1>
		<cfelse>
			<cfset k = i + 1>
		</cfif>
		<cfset thePage = ReplaceList(form.singleHeader,'$$albumTitle$$,$$totImages$$,$$imgDescr$$,$$imgCurrNumb$$', '#AlbumTitle#,#TotImages#,#ImageDescr#,#i#') & '
			<div id="Title">#ImageDescr# (#i# of #TotImages#)</div>
			<div id="ImageNav"><!-- the image navigation toolbar -->
					<table width="50%">
						<tr>
							<td width="33%" align="left">
								<a title="#ImageDescr#" href="#URLEncodedFormat(Left(ImageList[j], Len(ImageList[j])-4))#.#form.fileType#">Previous</a></td>
							<td width="34%" align="center">
								<a href="../index.#form.FileType#" title="Back to home">Home</a></td>
							<td width="33%" align="right">
								<a href="#URLEncodedFormat(Left(ImageList[k], Len(ImageList[k])-4))#.#form.fileType#" title="#Left(ImageList[k], Len(ImageList[k])-4)#">Next</a></td>
						</tr>
					</table>
			</div>
			<div id="Image">
			<!-- the single image -->
				<img src="../images/#URLEncodedFormat(ImageList[i])#" alt="#Left(ImageList[i], Len(ImageList[i])-4)#" class="Image" />
			</div>
		' & ReplaceList(form.singleFooter,'$$albumTitle$$,$$totImages$$,$$imgDescr$$,$$imgCurrNumb$$', '#AlbumTitle#,#TotImages#,#ImageDescr#,#i#')>
	
	<!--- Write the file to the destination directory --->
		<cftry>
			<cffile action="write" file="#form.destDir#\pages\#Left(ImageList[i], Len(ImageList[i])-4)#.#form.FileType#" output="#thePage#" charset="iso-8859-1">
			<cfcatch>
				<br><strong>Error saving <cfoutput>#form.destDir#\pages\#Left(ImageList[i], Len(ImageList[i])-4)#.#form.FileType#</cfoutput></strong>: <cfoutput>#cfcatch.Message#</cfoutput><br>
			</cfcatch>
		</cftry>
		
	<!--- Build the thumbnail home page --->
		<cfset indexTable = indexTable & "
		#IIF(i MOD form.thRows EQ 1, DE('<tr>'), DE(''))#
			<td valign=""top"" align=""center"" class=""ImageTd"">
				<a href=""pages/#URLEncodedFormat(ImageDescr)#.#form.fileType#""><img src=""thumbs/#ImageList[i]#"" class=""ImageList"" width=""#Fix(ThumbWidth)#""  alt=""#ImageDescr#"" /></a><br />
				#ImageDescr#
			</td>
		#IIF(i MOD form.thRows EQ 0, DE('</tr>'), DE(''))#">				
</cfloop>
	
	<!--- save the home page --->
	
	<cfset indexTable = ReplaceList(form.thumbHeader,'$$albumTitle$$,$$totImages$$', '#AlbumTitle#,#ArrayLen(ImageList)#') & '
		<div id="Title">#AlbumTitle# (#ArrayLen(ImageList)# images).</div>
		<div id="ImageList"><table class="ImageTable">#IndexTable#</table><div class="credits">Album made with <a href="http://www.bellavite.com/en/" target="_blank">bellaAlbum</a></div></div>' &  ReplaceList(form.thumbHeader,'$$albumTitle$$,$$totImages$$', '#AlbumTitle#,#ArrayLen(ImageList)#')>
	<cftry>
		<cffile action="write" file="#form.destDir#\index.#form.FileType#" output="#indexTable#">		
		<cfcatch>
			<br><strong>Error saving <cfoutput>#form.destDir#\index.#form.FileType#</cfoutput></strong>: <cfoutput>#cfcatch.Message#</cfoutput><br>
		</cfcatch>
	</cftry>
	
	<!--- Reset the status bar --->
	<script language="JavaScript1.1">
	<!--
	    document.getElementById('progressBarDescr').innerHTML='Done.';
		 document.getElementById('progressBar').style.background='#CCC';
	//-->
	</script>
	

		<strong><br>Finished!</strong><br>
		Your <cfoutput><strong>#form.albumTitle#</strong></cfoutput> album is saved into the <cfoutput><strong>#form.destDir#</strong></cfoutput> directory.
		<br>
		<script language="JavaScript">
		<!--
			alert('<cfoutput>#form.albumTitle#</cfoutput> completed.');
		//-->
		</script>
</p>


</body>
</html>
<cfabort>
