<cfcontent type="text/html; charset=utf-8">
<cfprocessingdirective pageencoding="utf-8">
<cfflush interval="2">

<!--- Copyright 2003 by Giampaolo Bellavite 
	  - All rights reserved
--->


<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>GB_Album Progress Status</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link href="style.css" rel="stylesheet" type="text/css">

</head>

<body>
<h1>&nbsp;&nbsp;bellaAlbum Progress Status</h1>
<p>
	
<!--- Create the directories structure --->
	<cfif directoryExists(form.origDir)>
		<cftry>
			<cfdirectory action="list" name="FileList" directory="#form.origDir#" filter="*.jpg" sort="#form.sortBy#">
			<cfcatch>
				<cfoutput>#cfcatch.Message#</cfoutput><cfabort>
			</cfcatch>
		</cftry>
	<cfelse>
		<cfoutput>The directory "#form.origDir#" doesn't exists.</cfoutput>
		<cfabort>
	</cfif>
	<strong><cfoutput>#filelist.recordCount#</strong> images into the #form.origDir# directory.</cfoutput><br><br>
	
	<cfif filelist.recordCount EQ 0>
		Please choose a directory with some JPGs!
		<cfabort>
	</cfif>
	<strong>Please wait...</strong><br><br>
	<cfif NOT directoryExists(form.destDir)>
	<strong>Building directory structure...</strong><br><br>
		<cftry>
			<cfdirectory action="create" directory="#form.destDir#">
			<cfcatch>
				<cfoutput>#cfcatch.Message#</cfoutput><cfabort>
			</cfcatch>
		</cftry>
		<cfoutput>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Directory "#form.destDir#" was created successfully.<br></cfoutput>

		<cftry>
			<cfdirectory action="create" directory="#form.destDir#\images">
			<cfcatch>
				<cfoutput>#cfcatch.Message#</cfoutput><cfabort>
			</cfcatch>
		</cftry>
		<cfoutput>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Directory "#form.destDir#images" was created successfully.<br></cfoutput>
		
		<cftry>
			<cfdirectory action="create" directory="#form.destDir#\thumbs">
			<cfcatch>
				<cfoutput>#cfcatch.Message#</cfoutput><cfabort>
			</cfcatch>
		</cftry>
		<cfoutput>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Directory "#form.destDir#thumbs" was created successfully.<br></cfoutput>

		<cftry>
			<cfdirectory action="create" directory="#form.destDir#\pages">
			<cfcatch>
				<cfoutput>#cfcatch.Message#</cfoutput><cfabort>
			</cfcatch>
		</cftry>
		<cfoutput>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Directory "#form.destDir#pages" was created successfully.<br></cfoutput>

	</cfif>


	<!--- Copy the css file --->
	<cftry>
			<cffile action="copy"  source="#ExpandPath('.')#\album.css" destination="#form.destDir#\album.css">
			<cfcatch>
				<cfoutput>#cfcatch.Message#</cfoutput><cfabort>
			</cfcatch>
		</cftry>
		<cfoutput>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br>Album.css file copied successfully.<br></cfoutput>

	

	<!--- Build an array with the image list --->
	<cfset ImageList = ArrayNew(1)>
	<cfloop query="FileList">
		<cfset ArrayAppend(ImageList, Name)>
	</cfloop>

	<!--- build the thumbnail page --->
	<cfset indexTable = "">
	<br><strong>Building images and thumbnails...</strong><br><br>
	<!--- loop the image list --->
	<cfloop from="1" to="#ArrayLen(ImageList)#" index="i">
		<cfset ImageDescr = Left(ImageList[i], Len(ImageList[i])-4)> <!--- Get the imageDescription from the file name --->
		<cfset TotImages = ArrayLen(ImageList)>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Processing <cfoutput>#ImageList[i]# (#i# of #ArrayLen(ImageList)#)...</cfoutput><br>
		
		<!--- build the thumnails images --->
		<cftry>
			<cfobject type="com" name="objEncoder" class="GraphicsProcessor2002.JPEGEncoderInfo" action="create">
			<cfset objEncoder.Quality = form.JPGQual>
			<cfobject type="COM" name="ObjRaster" class="GraphicsProcessor2002.RasterObject" action="create">
			<cfset objRaster.LoadFile("#form.origDir#\#ImageList[i]#")>
			<cfset ThumbWidth = form.thumbWidth>
			<cfset ThumbHeight = ThumbWidth * (objRaster.Height / objRaster.Width)>
			<cfset objRaster.Resize(ThumbWidth, ThumbHeight)>
			<cfset objRaster.SaveFile("#form.destDir#\thumbs\#ImageList[i]#", objEncoder)>
			<cfcatch>
				<br><strong>Error saving <cfoutput>#ImageList[i]#</cfoutput></strong>: <cfoutput>#cfcatch.Message#</cfoutput><br>
			</cfcatch>
		</cftry>
		<!--- copy original images to the destination directory --->
			<cfif isDefined('form.IMGWIDTHYN')> <!--- if original images not have to be resized... --->
				<cffile action="copy"  source="#form.origDir#\#ImageList[i]#" destination="#form.destDir#\images\#ImageList[i]#">
			<cfelse>
				<cftry>
					<cfobject type="com" name="objEncoderBig" class="GraphicsProcessor2002.JPEGEncoderInfo" action="create">
					<cfset objEncoderBig.Quality = form.JPGQual>
					<cfobject type="COM" name="ObjRasterBig" class="GraphicsProcessor2002.RasterObject" action="create">
					<cfset objRasterBig.LoadFile("#form.origDir#\#ImageList[i]#")>
					<cfset ThumbWidthBig = form.ImagesWidth>
					<cfset ThumbHeightBig = ThumbWidthBig * (objRasterBig.Height / objRasterBig.Width)>
					<cfset objRasterBig.Resize(ThumbWidthBig, ThumbHeightBig)>
					<cfset objRasterBig.SaveFile("#form.destDir#\images\#ImageList[i]#", objEncoderBig)>				
					<cfcatch>
				<br><strong>Error saving <cfoutput>#ImageList[i]#</cfoutput></strong>: <cfoutput>#cfcatch.Message#</cfoutput><br>
					</cfcatch>
				</cftry>
			</cfif>
	
	
	<!--- build single html file for every images --->
		<cfif i - 1 EQ 0>
			<cfset j = ArrayLen(ImageList)>
		<cfelse>
			<cfset j = i - 1>
		</cfif>
		<cfif i + 1 GT ArrayLen(ImageList)>
			<cfset k = 1>
		<cfelse>
			<cfset k = i + 1>
		</cfif>
		<cfset thePage = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<meta http-equiv="content-type" content="text/html;charset=iso-8859-1" />
		<title>#Left(ImageList[i], Len(ImageList[i])-4)# - #AlbumTitle# di Giampaolo Bellavite</title>
		<link href="../../css/style.css" rel="stylesheet" type="text/css" />
	</head>

	<body>
	 <div id="AlbumDetailLogo">
		<a href="../index.cfm"><img alt="Ipotesi cosmiche di lavoro" height="60" border="0" width="320" src="../../images/logo.gif" /></a><img src="../title.gif" alt="#AlbumTitle#" /></div>
	
	<div id="AlbumDetailMainContent">
		<div id="Title">#Left(ImageList[i], Len(ImageList[i])-4)# (#i# di #ArrayLen(ImageList)#)</div>
		<div id="ImageNav"><table class="imageNav"><tr><td width="33%" align="left"><a title="#Left(ImageList[j], Len(ImageList[j])-4)#" href="#URLEncodedFormat(Left(ImageList[j], Len(ImageList[j])-4))#.#form.FileType#">Precedente</a></td><td width="34%" align="center"><a href="../index.#form.FileType#" title="Torna all''inizio">Inizio</a><td width="33%" align="right"><a href="#URLEncodedFormat(Left(ImageList[k], Len(ImageList[k])-4))#.#form.FileType#" title="#Left(ImageList[k], Len(ImageList[k])-4)#">Successiva</a></td></table></div>
		<div id="Image">
			<img src="../images/#URLEncodedFormat(ImageList[i])#" alt="#Left(ImageList[i], Len(ImageList[i])-4)#" class="Image" />
		</div>
		</div><div id="AlbumDetailFooter">&copy; 2000, 2003 Giampaolo Bellavite</div></body></html>'>
	
	<!--- Write the file to the destination directory --->
		<cftry>
			<cffile action="write" file="#form.destDir#\pages\#Left(ImageList[i], Len(ImageList[i])-4)#.#form.FileType#" output="#thePage#" charset="iso-8859-1">
			<cfcatch>
				<br><strong>Error saving <cfoutput>#form.destDir#\pages\#Left(ImageList[i], Len(ImageList[i])-4)#.#form.FileType#</cfoutput></strong>: <cfoutput>#cfcatch.Message#</cfoutput><br>
			</cfcatch>
		</cftry>
		
	<!--- Build the thumbnail home page --->
		<cfset indexTable = indexTable & "
		#IIF(i MOD form.thRows EQ 1, DE('<tr>'), DE(''))#
			<td valign=""top"" align=""center"">
				<a href=""pages/#URLEncodedFormat(Left(ImageList[i], Len(ImageList[i])-4))#.#form.FileType#""><img src=""thumbs/#URLEncodedFormat(ImageList[i])#"" class=""ImageList"" width=""#ThumbWidth#"" height=""#ThumbHeight#"" alt=""#Left(ImageList[i], Len(ImageList[i])-4)#"" /></a><br />#Left(ImageList[i], Len(ImageList[i])-4)#
			</td>
		#IIF(i MOD form.thRows EQ 0, DE('</tr>'), DE(''))#">				
</cfloop>
	
	<!--- save the home page --->
	
	<cfset indexTable = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<meta http-equiv="content-type" content="text/html;charset=iso-8859-1" />
		<title>#AlbumTitle# di Giampaolo Bellavite</title>
		<link href="../css/style.css" rel="stylesheet" type="text/css" />
	</head>

	<body>
	 <div id="logo">
		<a href="index.cfm"><img alt="Ipotesi cosmiche di lavoro" height="60" border="0" width="320" src="../images/logo.gif" /></a><img src="title.gif" alt="#AlbumTitle#" /></div>

	<div id="Navigation">
			<br />
			<div class="Links">
				<span class="LinksTitle"><a href="../foto/">Indice delle foto</a></span>
			</div>
		<MM:BeginLock translatorClass="MM_SSI" type="ssi" orig="%3Ccfinclude template=%22../include/site_navigation.cfm%22%3E" fileRef="../include/site_navigation.cfm" depFiles="file:///C|/CFusionMX/wwwroot/bellavite.com/include/site_navigation.cfm">			<br />
			<div class="Links">
				<span class="LinksTitle"><a href="../bellablog/">Torna al bellablog</a></span>
			</div>
<MM:EndLock>
		<MM:BeginLock translatorClass="MM_SSI" type="ssi" orig="%3Ccfinclude template=%22../include/navigation.cfm%22%3E" fileRef="../include/navigation.cfm" depFiles="file:///C|/CFusionMX/wwwroot/bellavite.com/include/navigation.cfm"><hr />
			<div class="Links">
				<span class="LinksTitle">Le mie fotografie</span>
				<br />
						<span class="LinksElement"><a href="../foto_album_milano">Città di Milano</a></span><br />
						<span class="LinksElement"><a href="../foto_album_verona">Città di Verona</a></span><br />
						<span class="LinksElement"><a href="../foto_album_funes">Val di funes</a></span><br />
						<span class="LinksElement"><a href="../foto">Altre foto...</a></span><br />
			</div>

		<hr />
			<div class="Links">
				<span class="LinksTitle">Su di me</span>
				<br />
						<span class="LinksElement"><a href="../aboutme/lavori.cfm">Lavori e progetti</a></span><br />
						<span class="LinksElement"><a href="../aboutme/curriculum.cfm">Curriculum vitae</a></span><br />
						<span class="LinksElement"><a href="../aboutme/contattami.cfm">Contattami</a></span><br />
			</div>
		
		<hr />
<div class="Links">
				<span class="LinksTitle">Programmazione web</span>
				<br />
						<span class="LinksElement"><a href="../web/dreamweaver.cfm">Estensioni di Dreamweaver</a></span><br />
			<span class="LinksElement"><a href="../web/coldfusion.cfm">Area ColdFusion MX</a></span></div>
<MM:EndLock>
	</div>
	
	<div id="mainContent">
		<div id="Title">#AlbumTitle# (#ArrayLen(ImageList)# foto).</div>
		<div id="ImageList"><table>#IndexTable#</table></div></div><div id="footer">&copy; 2000, 2003 Giampaolo Bellavite</div></body></html>'>
	<cftry>
		<cffile action="write" file="#form.destDir#\index.#form.FileType#" output="#indexTable#">		
		<cfcatch>
			<br><strong>Error saving <cfoutput>#form.destDir#\index.#form.FileType#</cfoutput></strong>: <cfoutput>#cfcatch.Message#</cfoutput><br>
		</cfcatch>
	</cftry>


		<strong><br>Finished!</strong><br>
		Your <cfoutput><strong>#form.albumTitle#</strong></cfoutput> album is saved into the <cfoutput><strong>#form.destDir#</strong></cfoutput> directory.
		<br>
		<script language="JavaScript">
			alert('<cfoutput>#form.albumTitle#</cfoutput> completed.');
		</script>
</p>


</body>
</html>
<cfabort>
