
<!--- Catch the IrfanView Directory from the registry --->
<cftry>
<cfregistry action="getAll" branch="HKEY_CLASSES_ROOT\IrfanView\shell\open\command" name="Reg">
<cfloop query="reg">
	<cfif ListContainsNoCase(Reg.Value, 'i_view32.exe', " ")>
		<cfset irfanPath = ListFirst(Replace(Reg.Value, '"', '', "ALL"), ' ')>
	</cfif>
</cfloop>
	<cfcatch>
		<cfset irfanPath = "">
	</cfcatch>
</cftry>

<!--- Copyright 2003 by Giampaolo Bellavite 
	  - All rights reserved
--->

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>bellaAlbum Configurator</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link href="style.css" rel="stylesheet" type="text/css">
<script language="JavaScript" type="text/JavaScript">
<!--
function MM_popupMsg(msg) { //v1.0
  alert(msg);
}

function MM_callJS(jsStr) { //v2.0
  return eval(jsStr)
}
//-->
</script>
</head>

<body>

<table>
	<tr>
		<td style="padding-left: 10px; width: 620px">
			<h1>bellaAlbum Configurator</h1>
			<p>
				Version 1.1.0 (July 2003) - <a href="whatsnew.htm">What's new</a><br>
			 (C) 2003 by <a href="http://www.bellavite.com/en/" target="_blank">Giampaolo Bellavite</a>. Please read the... <a href="readme.htm">ReadMe</a> file!   
		 <hr>
			</p>		 <p>
			To create your Web Album, please change the following settings as you wish, then click the &quot;Create&quot; button.<br>
				Please ensure you have  Javascript enabled and Internet Explorer 6.0 or Mozilla. </p>

			<form method="post" action="creating.cfm">
			<fieldset>
				<legend>Directories</legend>
				<div class="configp">
					<table width="100%" border="0" cellpadding="3" cellspacing="1" class="configp">
						<tr>
							<td width="150" nowrap>Original images directory: </td>
							<td width="450"><input name="origDir" type="text" id="origDir" onfocus="this.select();" size="40"></td>
						</tr>
						<tr>
							<td width="150" nowrap>&nbsp;</td>
							<td width="450">Insert the absolute server path where original images are stored in. For example, &quot;C:\MyImages\&quot;. Images must be in JPG format.</td>
						</tr>
						<tr>
                        	<td width="150" nowrap>Destination directory: </td>
                        	<td width="450"><input name="destDir" type="text" id="destDir" onfocus="this.select();" size="40">
                   		 </td>
						</tr>
						<tr>
                        	<td width="150" nowrap>&nbsp;</td>
                        	<td width="450">Insert the absolute server path where the web album files will be saved. For example, &quot;C:\MyNewAlbum\&quot;.</td>
						</tr>
						<tr valign="top">
                        	<td align="right" nowrap="nowrap"><img src="bulb.gif" width="10" height="18" /></td>
                        	<td><strong>Tips:</strong> use high resolution JPGs. Rename all your original images with a short description, (for example, &quot;My home last year.jpg&quot;). Remember: the file name will be used for a short description in the web album!</td>
						</tr>
				 </table>
				</div>

			</fieldset>
			
			<fieldset>
				<legend>Album details</legend>
				<div class="configp">
					<table width="100%" border="0" cellpadding="3" cellspacing="1" class="configp">
						<tr>
							<td width="150" nowrap>Album Title: </td>
						 <td width="450"><input name="albumTitle" type="text" id="albumTitle" onfocus="this.select();" size="50"></td>
						</tr>
						<tr>
							<td width="150" nowrap>Thumbnails width:</td>
							<td width="450"><input name="thumbWidth" type="text" id="thumbWidth" onfocus="this.select();" value="140" size="3" maxlength="3">
							px &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;JPG Quality: 
							<input name="JPGQual" type="text" id="JPGQual" onfocus="this.select();" value="80" size="3" maxlength="3"> 
							(100=max)</td>
						</tr>
						<tr>
							<td nowrap>Thumbnails/row:</td>
							<td><input name="thRows" type="text" id="thRows" onfocus="this.select();" value="3" size="3" maxlength="3"></td>
						</tr>
						<tr>
                        	<td width="150" nowrap>Save files as:</td>
                        	<td width="450"><input type="radio" name="FileType" value="cfm" id="filetype1">
                        		<label for="filetype1">ColdFusion template (.cfm) </label>
                        			<input name="FileType" type="radio" value="htm" checked  id="filetype2">
                        			<label for="filetype2">HTML template (.htm)</label>
</td>
					 </tr>
						<tr valign="top">
                        	<td align="right" nowrap="nowrap"><img src="bulb.gif" width="10" height="18" /></td>
                        	<td><strong>Tip:</strong> choose ColdFusion template if you want to add custom CFML code in your template.</td>
						</tr>
						<tr>
                        	<td width="150" nowrap>Zoomed images width:</td>
                        	<td width="450"><input name="imagesWidth" type="text" id="imagesWidth" onfocus="this.select();" value="800" size="4" maxlength="4">
px &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<input name="imgWidthYN" type="checkbox" id="imgWidthYN" value="1" onclick="if (this.checked==true) { document.getElementById('imagesWidth').disabled=true } else (document.getElementById('imagesWidth').disabled=false)">
<label for="imgWidthYN">Don't change images width</label></td>
						</tr>
						<tr>
							<td nowrap>Sort images by:</td>
							<td><select name="sortBy" id="sortBy">
								<option value="name ASC">File name (description)
								<option value="datelastmodified ASC">Date ascending
								<option value="datelastmodified DESC">Date descending                                
							</select></td>
						</tr>
						<tr>
							<td nowrap valign="top">Images manipulation tool:</td>
							<td>
							 <input type="radio" name="tool" id="tool1" value="irfanview" onclick="if (this.checked==true) { document.getElementById('irfanPath').disabled=false } else (document.getElementById('irfanPath').disabled=true)">  
								<label for=tool1>IrfanView (Please specify the complete i_view32.exe path)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<input name="irfanPath" type="text" disabled id="irfanPath" onfocus="this.select();" value="<cfoutput>#irfanPath#</cfoutput>" size="50"></label>
<br>
								<input type="radio" name="tool"  id="tool2" value="aurigma" onclick="if (this.checked==true) { document.getElementById('irfanPath').disabled=true } else (document.getElementById('irfanPath').disabled=false)">
									<label for=tool2>Aurigma Graphics Processor<br>
								
									</td>

					 </tr>
						<tr valign="top">
                        	<td align="right" nowrap="nowrap"><img src="bulb.gif" width="10" height="18" /></td>
                        	<td><strong>What's this?</strong> bellaAlbum has to manipulate images while creating the Album. You <strong>must</strong> have installed one of the tools listed above in order to create the Album. Please refer to the <a href="readme.htm">ReadMe</a> file in order to understand where get those tools.</td>
						</tr>
				 </table>
				</div>

			</fieldset><br>
<br>

			<input type="submit" value="Create album" style="height: 22px;">
			<hr>
			
			<fieldset>
				<legend>Advanced template editing</legend>
			<div class="configp">
 				You can insert your custom HTML or CFML code for the thumbnail page and for images' pages. If you insert CFML code remember to set the save files as option to &quot;ColdFusion template&quot;.<br>You can use also <a href="#" onclick="MM_popupMsg('Macros available into the thumbnail template:\r$$AlbumTitle$$ = the album title\r$$totImages$$ = total images number\r\rMacros available into the single image template:\r$$AlbumTitle$$ = the album title\r$$totImages$$ = total images number\r$$imgDescr$$ = the image description\r$$imgCurrNumb$$ = the current image number\r\rPlease note: macros are Case Sensitive!');return false">special macro</a>  to get some dynamic values of the album.<br>
<br>

				<strong>Thumbnail template headers:</strong><br>
				<textarea name="thumbHeader" style="width: 587px" rows="8" wrap="OFF" id="thumbHeader"><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<meta http-equiv="content-type" content="text/html;charset=iso-8859-1" />
		<title>$$albumTitle$$</title>
		<link href="album.css" rel="stylesheet" type="text/css">
	</head>

	<body></textarea>
			    <br>
			    <strong><br>
			    Thumbnail template footer:</strong><br />
                <textarea name="thumbFooter" style="width: 587px" rows="8" wrap="off" id="thumbFooter">
</body></html></textarea>
                <strong><br />
                <br>
                Single page header:</strong><br />
<textarea name="singleHeader" style="width: 587px" rows="8" wrap="off" id="textarea2"><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<meta http-equiv="content-type" content="text/html;charset=iso-8859-1" />
		<title>$$imgDescr$$ - $$albumTitle$$</title>
		<link href="../album.css" rel="stylesheet" type="text/css">
	</head>

	<body></textarea>
<br>
<br>
<strong>Single page footer:</strong><br />
<textarea name="singleFooter" style="width: 587px" rows="8" wrap="off" id="textarea3"></body></html></textarea>
			</div>

			</fieldset><br><br>
						<input type="submit" value="Create album" style="height: 22px;">
			<hr>
			
			
			</form>
		</td>
	</tr>
</table>
<h1>&nbsp;</h1>
</body>
</html>
